#include "Config.h"
#include "Messages.h"
#include <fstream>
#include <iostream>
#include <netinet/in.h>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/fcntl.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/types.h>
#include <sys/un.h>

#define handle_error(msg) \
    do { perror(msg); exit(EXIT_FAILURE); } while (0)

#define MY_SOCK_PATH "."
#define LISTEN_BACKLOG 50

int port = 2727;
int bufferSize = 32768;

void error(char *msg) {
    perror(msg);
    exit(1);
}


void listen(int port) {
    int sockfd, newsockfd, portno, clilen;
    char buffer[bufferSize];
    struct sockaddr_in serv_addr, cli_addr;
    int n;
    Messages messages;

    sockfd = socket(AF_INET, SOCK_STREAM, 0); // vytvorime novy socket
    if (sockfd < 0) {
        error("Nelze otevrit socket :(");
    }
    bzero((char *) &serv_addr, sizeof(serv_addr)); // vynulujem si informace
    portno = port; // naplnime si informace o serveru
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = INADDR_ANY;
    serv_addr.sin_port = htons(portno);

    if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
        error("Nelze naslouchat :(");
    }
    listen(sockfd, 5);

    clilen = sizeof(cli_addr);
    while (newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, (socklen_t*) &clilen)) { // Zadost o nove spojeni
        if (newsockfd < 0) {
            error("Chyba pri prijmu :(");
        }
        bzero(buffer, bufferSize);
        timeb time_a;
        ftime(&time_a);
        n = read(newsockfd,buffer, bufferSize); // Nacteme si data
        timeb time_b;
        ftime(&time_b);
        if (n < 0) {
            error("Chyba cteni z bufferu :(");
        }

        char * pch;
        pch = strchr(buffer, '#'); // Nalezneme si delici znak

        if (pch == NULL) { // Jestlize delici znak neni, prisel nam nejaky blabol
            continue;
        }

        char tmp1[bufferSize + 100];
        char tmp2[bufferSize + 100];
        strncpy(tmp1, buffer, pch - buffer); // Do tmp1 ulozime port na kterem klient bude poslouchat
        strcpy(tmp2, pch + 1); // Do tmp2 ulozime zpravu
        tmp1[pch - buffer] = 0; // Jelikoz C, musime ukoncit tmp1
        int clientPort = atoi(tmp1); // Prelozime port klienta
        printf("Prijmuli jsme: '%c' od %d\n", buffer[10], clientPort);
        string message = tmp2; // Ulozime si zpravu do poradne struktury

        long diff = time_b.time*1000 + time_b.millitm - time_a.time*1000 - time_a.millitm;

        messages.addClient((u_long)cli_addr.sin_addr.s_addr, clientPort); // Mame noveho klienta
        messages.sendMessage(message, clientPort, diff); // Chceme vsem klientum poslat novou zpravu
    }
}


int main(int argc, char *argv[]) {
    if (argc > 1) {
        istringstream buffer(argv[1]);
        buffer >> port;
        if ((port < 1) || (port > 65535)) {
            cerr << "Port " << port << " je mimo povoleny rozsah" << endl;
            exit(EXIT_FAILURE);
        }
    }

    cout << "Pokousime se poslouchat na portu: " << port << endl;
    listen(port); // poslouchame

    return 0;
}


